﻿USE [msdb]
GO


DECLARE @OwnerLogin NVARCHAR(MAX) = N'Domain\user';
DECLARE @ServerName NVARCHAR(MAX) = N'ComputerName';
DECLARE @DatabaseName NVARCHAR(MAX) = N'NiceAN';

BEGIN TRY
	BEGIN TRAN
		DECLARE @jobId BINARY(16);

		EXEC msdb.dbo.sp_add_job @job_name=N'ArchivatorJob', 
			@enabled=1, 
			@notify_level_eventlog=0, 
			@notify_level_email=2, 
			@notify_level_netsend=2, 
			@notify_level_page=2, 
			@delete_level=0, 
			@description=N'Job for triggering archivating process for NiceLabel Control Center.', 
			@category_name=N'[Uncategorized (Local)]', 
			@owner_login_name=@OwnerLogin, @job_id = @jobId OUTPUT;
		
		EXEC msdb.dbo.sp_add_jobserver @job_name=N'ArchivatorJob', @server_name = @ServerName;

		EXEC msdb.dbo.sp_add_jobstep @job_name=N'ArchivatorJob', @step_name=N'StartArchivation', 
			@step_id=1, 
			@cmdexec_success_code=0, 
			@on_success_action=1, 
			@on_fail_action=2, 
			@retry_attempts=0, 
			@retry_interval=0, 
			@os_run_priority=0, @subsystem=N'TSQL', 
			@command=N'EXEC nan.ProcessArchivation', 
			@database_name=@DatabaseName, 
			@flags=0;

		EXEC msdb.dbo.sp_update_job @job_name=N'ArchivatorJob', 
			@enabled=1, 
			@start_step_id=1, 
			@notify_level_eventlog=0, 
			@notify_level_email=2, 
			@notify_level_netsend=2, 
			@notify_level_page=2, 
			@delete_level=0, 
			@description=N'Job for triggering archivating process for NiceLabel Control Center.', 
			@category_name=N'[Uncategorized (Local)]', 
			@owner_login_name=@OwnerLogin, 
			@notify_email_operator_name=N'', 
			@notify_netsend_operator_name=N'', 
			@notify_page_operator_name=N'';

		DECLARE @schedule_id INT;

		EXEC msdb.dbo.sp_add_jobschedule @job_name=N'ArchivatorJob', @name=N'DailyRun', 
			@enabled=1, 
			@freq_type=4, 
			@freq_interval=1, 
			@freq_subday_type=1, 
			@freq_subday_interval=0, 
			@freq_relative_interval=0, 
			@freq_recurrence_factor=1, 
			@active_start_date=20170411, 
			@active_end_date=99991231, 
			@active_start_time=0, 
			@active_end_time=235959, @schedule_id = @schedule_id OUTPUT;
	COMMIT TRAN
END TRY
BEGIN CATCH
	PRINT 'THERE WAS AN ERROR WHILE CREATING ARCHIVATOR JOB:';
	PRINT CONVERT(NVARCHAR(MAX), ERROR_NUMBER()) + ': ' + ERROR_MESSAGE();
	ROLLBACK TRAN;
END CATCH
GO